      PROGRAM RPLOT
C
C********************************************************************
C     EXAMPLE PROGRAM FOR READING BINARY PLOT DATA
C*******************************************************************
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      DOUBLE PRECISION STRESS(22)
C
C     OPEN BINARY PLOT DATA FILE
C
      OPEN (20, FILE='DES01.PST', STATUS='OLD', FORM='UNFORMATTED',
     *     IOSTAT=KERR, ERR=997)
C
C     READ HEADER
C
  100 READ(20) ICODE,IETYPE,LOAD,NREC,NWORD
C
C     CHECK FOR END OF FILE
C
      IF (ICODE.EQ.0) GO TO 997
C
      IF (ICODE.EQ.1) THEN
C
C        ICODE=1 => DISPLACMENTS
C        READ IN TRANSLATIONAL DISPLACEMENTS AND WRITE TO SCREEN
C
         WRITE(6,*) ' DISPLACEMENTS FOR LOADCASE ',LOAD
         WRITE(6,*) ' GRID ID        X              Y             Z'
         DO 200 I = 1,NREC
            READ(20) IGID,X,Y,Z
            WRITE(6,*) IGID,X,Y,Z
  200    CONTINUE
C
      ELSE IF (ICODE.EQ.2 .AND. IETYPE.EQ.7) THEN
C
C        READ IN HEXA ELEMENT (IETYPE=7) STRESSES (ICODE=2) AND
C        WRITE VON MISES STRESS (LOCATION NUMBER 7)  TO SCREEN
C
         WRITE(6,*) ' HEXA VON MISES STRESSES FOR LOADCASE ',LOAD
         WRITE(6,*) ' ELEM ID    STRESS'
         DO 300 I = 1,NREC
            READ(20) IEID,(STRESS(J),J=1,NWORD)
            WRITE(6,*) IEID,STRESS(7)
  300    CONTINUE
C
      ELSE
C
C        READ OVER UNWANTED OUTPUT
C 
         DO 400 I = 1,NREC
            READ(20) IDUMMY
  400    CONTINUE
      END IF
C
C     GO TO 100 AND READ NEXT HEADER
C
      GO TO 100
C
  997 IF (KERR.NE.0) WRITE(6,*) ' CAN''T OPEN PLOT FILE, REASON:',KERR
C
      END
